/**
 * generated by Xtext 2.25.0
 */
package tdt4250.xjava.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tdt4250.xjava.CompilationUnit;
import tdt4250.xjava.ImportStatement;
import tdt4250.xjava.PackageDeclaration;
import tdt4250.xjava.TypeDeclaration;
import tdt4250.xjava.XjavaPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Compilation Unit</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tdt4250.xjava.impl.CompilationUnitImpl#getPackageDecl <em>Package Decl</em>}</li>
 *   <li>{@link tdt4250.xjava.impl.CompilationUnitImpl#getImports <em>Imports</em>}</li>
 *   <li>{@link tdt4250.xjava.impl.CompilationUnitImpl#getClasses <em>Classes</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CompilationUnitImpl extends MinimalEObjectImpl.Container implements CompilationUnit
{
  /**
   * The cached value of the '{@link #getPackageDecl() <em>Package Decl</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPackageDecl()
   * @generated
   * @ordered
   */
  protected PackageDeclaration packageDecl;

  /**
   * The cached value of the '{@link #getImports() <em>Imports</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getImports()
   * @generated
   * @ordered
   */
  protected EList<ImportStatement> imports;

  /**
   * The cached value of the '{@link #getClasses() <em>Classes</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getClasses()
   * @generated
   * @ordered
   */
  protected EList<TypeDeclaration> classes;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CompilationUnitImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return XjavaPackage.Literals.COMPILATION_UNIT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public PackageDeclaration getPackageDecl()
  {
    return packageDecl;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetPackageDecl(PackageDeclaration newPackageDecl, NotificationChain msgs)
  {
    PackageDeclaration oldPackageDecl = packageDecl;
    packageDecl = newPackageDecl;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL, oldPackageDecl, newPackageDecl);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setPackageDecl(PackageDeclaration newPackageDecl)
  {
    if (newPackageDecl != packageDecl)
    {
      NotificationChain msgs = null;
      if (packageDecl != null)
        msgs = ((InternalEObject)packageDecl).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL, null, msgs);
      if (newPackageDecl != null)
        msgs = ((InternalEObject)newPackageDecl).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL, null, msgs);
      msgs = basicSetPackageDecl(newPackageDecl, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL, newPackageDecl, newPackageDecl));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<ImportStatement> getImports()
  {
    if (imports == null)
    {
      imports = new EObjectContainmentEList<ImportStatement>(ImportStatement.class, this, XjavaPackage.COMPILATION_UNIT__IMPORTS);
    }
    return imports;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<TypeDeclaration> getClasses()
  {
    if (classes == null)
    {
      classes = new EObjectContainmentEList<TypeDeclaration>(TypeDeclaration.class, this, XjavaPackage.COMPILATION_UNIT__CLASSES);
    }
    return classes;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL:
        return basicSetPackageDecl(null, msgs);
      case XjavaPackage.COMPILATION_UNIT__IMPORTS:
        return ((InternalEList<?>)getImports()).basicRemove(otherEnd, msgs);
      case XjavaPackage.COMPILATION_UNIT__CLASSES:
        return ((InternalEList<?>)getClasses()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL:
        return getPackageDecl();
      case XjavaPackage.COMPILATION_UNIT__IMPORTS:
        return getImports();
      case XjavaPackage.COMPILATION_UNIT__CLASSES:
        return getClasses();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL:
        setPackageDecl((PackageDeclaration)newValue);
        return;
      case XjavaPackage.COMPILATION_UNIT__IMPORTS:
        getImports().clear();
        getImports().addAll((Collection<? extends ImportStatement>)newValue);
        return;
      case XjavaPackage.COMPILATION_UNIT__CLASSES:
        getClasses().clear();
        getClasses().addAll((Collection<? extends TypeDeclaration>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL:
        setPackageDecl((PackageDeclaration)null);
        return;
      case XjavaPackage.COMPILATION_UNIT__IMPORTS:
        getImports().clear();
        return;
      case XjavaPackage.COMPILATION_UNIT__CLASSES:
        getClasses().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case XjavaPackage.COMPILATION_UNIT__PACKAGE_DECL:
        return packageDecl != null;
      case XjavaPackage.COMPILATION_UNIT__IMPORTS:
        return imports != null && !imports.isEmpty();
      case XjavaPackage.COMPILATION_UNIT__CLASSES:
        return classes != null && !classes.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //CompilationUnitImpl
